<?php

namespace Home\Controller;

use Think\Controller;
use Think\Db;

include '../Common/function.php';

class DeviceConfigController extends ComController
{
    private $host = "https://device.api.ct10649.com:8743/";
    private $appId = "wvdOfp7JVe0ULwnFKwBF0edfbcAa";
    private $secret = "Bihoe_rY9vebXMw6sFfpQy0jiRca";
    private $appId1 = "bIS92ndpAf_fhmPdLaNuTidbFfka";
    private $secret1 = "NZMe1G42OdSmzlEuDpR_3ywKPhIa";

//    public function getDeviceList()
//    {
//        $Data = I();
//        $company_code = $Data['company_code'];
//        $device_data1 = M()->query("SELECT a.id,a.owner_code,a.louyu,a.company,a.owner_name,a.dwtype,IF(timestampdiff(HOUR,max(`b`.`data_time`),now())<12,'在线','离线') AS device_state,a.install_time,a.unitinfo FROM sp_owner AS a JOIN sp_owner_status  AS b ON a.owner_code=b.device_id WHERE a.dwtype!=1 AND a.company='" . $company_code . "' GROUP BY a.owner_code ORDER BY a.install_time DESC");
//        $device_data2 = M()->query("SELECT a.id,a.owner_code,a.louyu,a.company,a.owner_name,a.dwtype,IF(true_status=0,'在线','离线') AS device_state,a.install_time,a.unitinfo FROM sp_owner AS a JOIN sp_devices_status AS b ON a.owner_code=b.deviceid WHERE a.company='" . $company_code . "' AND a.dwtype=1 GROUP BY a.owner_code ORDER BY a.install_time DESC");
//        $device_data = array_merge($device_data1, $device_data2);
//        array_multisort(array_column($device_data, 'install_time'), SORT_DESC, $device_data);
//        $res['msg'] = '操作成功';
//        $res['flag'] = true;
//        $res['data'] = $device_data;
//        echo json_encode($res);
//    }

    public function getDeviceList()
    {
        $Data = I();
        $company_code = $Data['company_code'];
        $dwtype = $Data['dwtype'];
        $transmission_mode = $Data['transmission_mode'];
        $where = "";
        if (!empty($dwtype)) {
            $where .= " and dwtype = '" . $dwtype . "' ";
        }

        if (!empty($transmission_mode)) {
            $where .= " and transfer_type = '" . $transmission_mode . "' ";
        }
        $start=($Data['page']-1)*$Data['pageSize'];
        if (!empty($Data['pageSize'])){
            $LIMIT=" LIMIT ".$start.",".$Data['pageSize'];
        }
        $device_data = M()->query("SELECT id,owner_code,louyu,company,owner_name,dwtype,install_time,unitinfo,transfer_type FROM sp_owner WHERE company='" . $company_code . "' " . $where . " GROUP BY owner_code ORDER BY id DESC ".$LIMIT);
        $res['msg'] = '操作成功';
        $res['flag'] = true;
        $res['data'] = $device_data;
        echo json_encode($res);
    }

    public function setDevice()
    {
        $Data = I('');
        $data['owner_code'] = $Data['device_code'];
        $data['owner_name'] = $Data['device_name'];
        $data['unitinfo'] = $Data['unitinfo'];
        $data['louyu'] = $Data['louyu'];
        $data['sim'] = $Data['sim'];
        $data['maintainTime'] = "";
        $data['dest_address'] = 0;
        $data['addr1'] = "";
        $data['addr2'] = "";
        $data['addr3'] = "";
        $data['address'] = "";
        $data['posistion'] = "";
        $data['install_time'] = date("Y-m-d H:i:s");
        $data['install_man'] = $_SESSION['phone'];
        $data['dwtype'] = $Data['type'];
        $data['owner_xh'] = '0,' . $data['owner_xh_a'] . $data['owner_xh_b'] . $data['owner_xh_c'];
        $data['s_interval'] = 8;
        $data['community'] = "";
        $data['company'] = $Data['company_code'];
        $data['rtmp'] = "";
        $data['hls'] = "";
        $data['html5'] = "";
        $data['danwei'] = $Data['danwei'];
        $data['owner_bl'] = $Data['owner_bl'];
        $data['push_param1'] = "4294967295";
        $data['push_param2'] = 0;
        $data['push_param3'] = 0;
        $data['push_param4'] = 0;
        $data['login_param'] = "";
        $data['transfer_type'] = $Data['transfer_type'];

        $data1['deviceid'] = $Data['device_code'];
        $data1['deviceno'] = 0;
        $data1['devicestatus'] = '75';
        $data1['statustime'] = 0;
        $data1['f_evt'] = 40;
        $data1['c_evt'] = "00";
        $data1['w_evt'] = "";
        $data1['true_status'] = '75';
        $data1['lastcommtime'] = '0';

        $data2['owner_code'] = $Data['device_code'];
        $data2['owner_dwtype'] = $Data['type'];
        $data2['device_name'] = $Data['device_name'];
        $data2['object_name'] = $Data['unitinfo'];
        $data2['min_level'] = $Data['louyu'];
        $data2['max_level'] = $Data['louyu'];
        $data2['is_top'] = $Data['is_top'];
        $data2['start_port'] = '0';
        $data2['rec_cur'] = '0';

        $data3['deviceType'] = $Data['deviceType'];//设备类型 水表 Smoke:烟感、MultiSensor：水表、WaterMeter：宇洁戎情水表、topsailSensor：拓扑索尔 烟感 TBSNode：拓扑索尔烟感
        $data3['manufacturerName'] = $Data['manufacturerName'];//厂商名称：ST、ZHYQ、shanghaijunyanTest、Topsail、Turboes
        $data3['model'] = $Data['model'];//设备型号 烟感型号:517N01、水表型号：PT124B-2892-010、宇洁戎情水表型号：WPTA、拓扑索尔水表液位：TH12、拓扑索尔烟感：Public
        $data3['location'] = $Data['location'];//地址 区域
        $data3['protocolType'] = $Data['protocolType'];//协议

        switch ($Data['type']) {
            case '1'://报警主机
                $data2['dwtype'] = 'YTUI';
                $Res1 = M('owner')->add($data);
                $Res2 = M('devices_status')->add($data1);
                $Res3 = M('object_share')->add($data2);
                break;
            case '2'://消防水
                $data2['dwtype'] = 'YTWP';
                $data2['start_port'] = '0';
                $data2['rec_cur'] = '0';
                $Res = M()->query("SELECT max(object_code) AS object_code FROM sp_object_share WHERE object_code LIKE '" . $data2['dwtype'] . "-" . $Data['company_code'] . "%'");
                if (empty($Res)) {
                    $data2['object_code'] = $data2['dwtype'] . '-' . $Data['company_code'] . '001';
                } else {
                    $sort = (int)substr($Res[0]['object_code'], 10, 3) + 1;
                    $num = str_pad($sort, 3, "0", STR_PAD_LEFT);
                    $data2['object_code'] = $data2['dwtype'] . '-' . $Data['company_code'] . $num;
                }
                switch ($data['transfer_type']) {
                    case 'NB':
                        if (empty($data3['deviceType']) || empty($data3['manufacturerName']) || empty($data3['model']) || empty($data3['location']) || empty($data3['protocolType'])) {
                            $res['msg'] = "请填写好必要内容";
                            $res['flag'] = false;
                            echo json_encode($res);
                            exit();
                        }
                        $R = ytapi187_query("select * from device where device_id='" . $Data['device_code'] . "'");
                        if (empty($R)) {
                            if (empty($Data['device_code']) || empty($Data['device_name'])) {
                                $res['msg'] = '请填写好必要内容';
                                $res['flag'] = false;
                                echo json_encode($res);
                                exit();
                            }

                            $token = json_decode(gettoken(), true);
                            $sendata = [
                                "verifyCode" => $Data['device_code'],//"868744030067098"
                                "nodeId" => $Data['device_code'],
                                "timeout" => 0
                            ];

                            $header = [
                                "Content-Type:application/json",
                                "app_key:" . $this->appId,
                                "Authorization:Bearer " . $token["accessToken"]
                            ];

                            $rescurl = curl($this->host . "iocm/app/reg/v1.1.0/deviceCredentials?appId=" . $this->appId, json_encode($sendata), $header);
                            if ($rescurl[0] == 200) {
                                $res1 = json_decode($rescurl[1], true);
                            } else {
                                $res['msg'] = $rescurl;
                                $res['flag'] = false;
                                echo json_encode($res);
                                exit();
                            }
                            $list = array();
                            $list['device_id'] = trim($Data['device_code']);
                            $list['name'] = $Data['device_name'];
                            $list['iot_id'] = $res1['deviceId'];
                            $list['psk'] = $res1['psk'];
                            $list['addtime'] = date('Y-m-d H:i:s');
                            $list['updatetime'] = date('Y-m-d H:i:s');
                            $device_table = "dev_" . $Data['device_code'];
                            $create_sql = "
                            CREATE TABLE `" . $device_table . "` (
                              `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
                              `device_id` varchar(200) DEFAULT NULL,
                              `iot_id` varchar(255) DEFAULT NULL,
                              `service` text,
                              `addtime` varchar(50) DEFAULT NULL,
                              `notifyType` varchar(50) DEFAULT NULL,
                              PRIMARY KEY (`id`)
                            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

                            ytapi187_inset($create_sql);

                            $rs = ytapi187_inset("INSERT INTO device (device_id,name,addtime,updatetime,iot_id,psk,manufacturerId,manufacturerName,deviceType
                                ,model,location,isSecure,status,protocolType,owner_id) values ('" . $list['device_id'] . "','" . $list['name'] . "','" . $list['addtime'] . "',
                                '" . $list['updatetime'] . "','" . $list['iot_id'] . "','" . $list['psk'] . "','','','','','','','','','')");
                            if ($rs) {
                                $owner1 = M()->query("SELECT company,louyu,unitinfo FROM sp_owner WHERE owner_code = '" . $Data['device_code'] . "'");
                                if ($owner1) {
                                    $data4['owner_name'] = $Data['device_name'];
                                    $data4['unitinfo'] = $Data['unitinfo'];
                                    $data4['louyu'] = $Data['louyu'];
                                    $data4['company'] = $Data['company_code'];
                                    $where4['owner_code'] = $Data['device_code'];
                                    $res4 = M('owner')->where($where4)->save($data4);
                                } else {
                                    $token = json_decode(gettoken(), true);
                                    $sendata = [
                                        "name" => $Data['device_code'],
                                        "deviceType" => $Data['deviceType'],
                                        "manufacturerName" => $Data['manufacturerName'],
                                        "manufacturerId" => $Data['manufacturerId'],//厂商ID ST、ZHYQ、JunyanTest、Topsail
                                        "model" => $Data['model'],
                                        "protocolType" => $Data['protocolType'],
                                        "location" => trim($Data['location'])
                                    ];
                                    $header = [
                                        "Content-Type:application/json",
                                        "app_key:" . $this->appId,
                                        "Authorization:Bearer " . $token["accessToken"]
                                    ];
                                    $rescurl = curl($this->host . "iocm/app/dm/v1.4.0/devices/" . $list['iot_id'] . "?appId=" . $this->appId, json_encode($sendata, 320), $header, "PUT");
                                }
                                if ($rescurl[0] == 204) {//成功
                                    $res1 = json_decode($rescurl[1], true);
                                } else {//失败
                                    $res['msg'] = $rescurl[1];
                                    $res['flag'] = false;
                                    echo json_encode($res);
                                    exit();
                                }

                                $device_update = ytapi187_inset("UPDATE device set deviceType='" . $Data['deviceType'] . "',name='" . $Data['device_name'] . "',manufacturerName=
                                '" . $Data['manufacturerName'] . "',model='" . $Data['model'] . "',isSecure='" . $Data['isSecure'] . "',manufacturerId='" . $Data['manufacturerId'] . "',
                                protocolType='" . $Data['protocolType'] . "',location='" . $Data['location'] . "',updatetime='" . date('Y-m-d H:i:s') . "' where device_id=
                                '" . $Data['device_code'] . "'");
                                $device_query = ytapi187_query("select * from device where device_id='" . $Data['device_code'] . "'");
                                $device_id = $device_query[0]['device_id'];
                                $deviceType = $Data['deviceType'];
                                $create_sql = addtable($device_id, $deviceType);
                                $table = Db::execute($create_sql);
                                $deviceStatus = M()->query("SELECT statustime FROM sp_devices_status WHERE deviceid = '" . $device_query[0]['device_id'] . "'");
                                if (!$deviceStatus) {
                                    $data6['deviceid'] = $device_query[0]['device_id'];
                                    $data6['deviceno'] = 0;
                                    $data6['devicestatus'] = '75';
                                    $data6['statustime'] = date('Y-m-d H:i:s');
                                    $data6['f_evt'] = 40;
                                    $data6['c_evt'] = 00;
                                    $data6['w_evt'] = "";
                                    $data6['true_status'] = '75';
                                    $data6['lastcommtime'] = '0';
                                    $Res2 = M('devices_status')->add($data6);
                                }
                                if ($Data['company_code']) {
                                    $Res1 = M('owner')->add($data);
//                                  $Res2 = M('devices_status')->add($data1);
                                    $Res3 = M('object_share')->add($data2);
                                }
                                if ($device_update) {
                                    $res['msg'] = "操作成功";
                                    $res['flag'] = true;
                                    echo json_encode($res);
                                    exit();
                                } else {
                                    $res['msg'] = "添加失败，请稍后再试";
                                    $res['flag'] = false;
                                    echo json_encode($res);
                                    exit();
                                }


                            } else {
                                $res['msg'] = "添加失败，请稍后再试";
                                $res['flag'] = false;
                                echo json_encode($res);
                                exit();
                            }
                        } else {
                            $res['msg'] = '该设备编号已经添加';
                            $res['flag'] = false;
                            echo json_encode($res);
                            exit();
                        }
                        break;
                    case 'Lora':
                    case '4G':
                        $Res1 = M('owner')->add($data);
                        $Res2 = M('devices_status')->add($data1);
                        $Res3 = M('object_share')->add($data2);
                        break;
                    default:
                        $res['msg'] = '操作失败，该传输方式不存在，请联系管理员';
                        $res['flag'] = false;
                        echo json_encode($res);
                        exit();
                }
                break;
            case '3'://烟感
                $data2['dwtype'] = 'YTSM';
                $data2['start_port'] = '0';
                $data2['rec_cur'] = '0';
                $Res = M()->query("SELECT max(object_code) AS object_code FROM sp_object_share WHERE object_code LIKE '" . $data2['dwtype'] . "-" . $Data['company_code'] . "%'");
                if (empty($Res)) {
                    $data2['object_code'] = $data2['dwtype'] . '-' . $Data['company_code'] . '001';
                } else {
                    $sort = (int)substr($Res[0]['object_code'], 10, 3) + 1;
                    $num = str_pad($sort, 3, "0", STR_PAD_LEFT);
                    $data2['object_code'] = $data2['dwtype'] . '-' . $Data['company_code'] . $num;
                }
                switch ($data['transfer_type']) {
                    case 'NB':
                        if (empty($data3['deviceType']) || empty($data3['manufacturerName']) || empty($data3['model']) || empty($data3['location']) || empty($data3['protocolType'])) {
                            $res['msg'] = "请填写好必要内容";
                            $res['flag'] = false;
                            echo json_encode($res);
                            exit();
                        }
                        $R = ytapi187_query("select * from device where device_id='" . $Data['device_code'] . "'");
                        if (empty($R)) {
                            if (empty($Data['device_code']) || empty($Data['device_name'])) {
                                $res['msg'] = '请填写好必要内容';
                                $res['flag'] = false;
                                echo json_encode($res);
                                exit();
                            }

                            $token = json_decode(gettoken1(), true);
                            $sendata = [
                                "verifyCode" => $Data['device_code'],//"868744030067098"
                                "nodeId" => $Data['device_code'],
                                "timeout" => 0
                            ];

                            $header = [
                                "Content-Type:application/json",
                                "app_key:" . $this->appId1,
                                "Authorization:Bearer " . $token["accessToken"]
                            ];

                            $rescurl = curl($this->host . "iocm/app/reg/v1.1.0/deviceCredentials?appId=" . $this->appId1, json_encode($sendata), $header);
                            if ($rescurl[0] == 200) {
                                $res1 = json_decode($rescurl[1], true);
                            } else {
                                $res['msg'] = $rescurl;
                                $res['flag'] = false;
                                echo json_encode($res);
                                exit();
                            }
                            $list = array();
                            $list['device_id'] = trim($Data['device_code']);
                            $list['name'] = $Data['device_name'];
                            $list['iot_id'] = $res1['deviceId'];
                            $list['psk'] = $res1['psk'];
                            $list['addtime'] = date('Y-m-d H:i:s');
                            $list['updatetime'] = date('Y-m-d H:i:s');
                            $device_table = "dev_" . $Data['device_code'];
                            $create_sql = "
                            CREATE TABLE `" . $device_table . "` (
                              `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
                              `device_id` varchar(200) DEFAULT NULL,
                              `iot_id` varchar(255) DEFAULT NULL,
                              `service` text,
                              `addtime` varchar(50) DEFAULT NULL,
                              `notifyType` varchar(50) DEFAULT NULL,
                              PRIMARY KEY (`id`)
                            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

                            ytapi187_inset($create_sql);

                            $rs = ytapi187_inset("INSERT INTO device (device_id,name,addtime,updatetime,iot_id,psk,manufacturerId,manufacturerName,deviceType
                                ,model,location,isSecure,status,protocolType,owner_id) values ('" . $list['device_id'] . "','" . $list['name'] . "','" . $list['addtime'] . "',
                                '" . $list['updatetime'] . "','" . $list['iot_id'] . "','" . $list['psk'] . "','','','','','','','','','')");
                            if ($rs) {
                                $owner1 = M()->query("SELECT company,louyu,unitinfo FROM sp_owner WHERE owner_code = '" . $Data['device_code'] . "'");
                                if ($owner1) {
                                    $data4['owner_name'] = $Data['device_name'];
                                    $data4['unitinfo'] = $Data['unitinfo'];
                                    $data4['louyu'] = $Data['louyu'];
                                    $data4['company'] = $Data['company_code'];
                                    $where4['owner_code'] = $Data['device_code'];
                                    $res4 = M('owner')->where($where4)->save($data4);
                                } else {
                                    $token = json_decode(gettoken1(), true);
                                    $sendata = [
                                        "name" => $Data['device_code'],
                                        "deviceType" => $Data['deviceType'],
                                        "manufacturerName" => $Data['manufacturerName'],
                                        "manufacturerId" => $Data['manufacturerId'],//厂商ID ST、ZHYQ、JunyanTest、Topsail
                                        "model" => $Data['model'],
                                        "protocolType" => $Data['protocolType'],
                                        "location" => trim($Data['location'])
                                    ];
                                    $header = [
                                        "Content-Type:application/json",
                                        "app_key:" . $this->appId1,
                                        "Authorization:Bearer " . $token["accessToken"]
                                    ];
                                    $rescurl = curl($this->host . "iocm/app/dm/v1.4.0/devices/" . $list['iot_id'] . "?appId=" . $this->appId1, json_encode($sendata, 320), $header, "PUT");
                                }
                                if ($rescurl[0] == 204) {//成功
                                    $res1 = json_decode($rescurl[1], true);
                                } else {//失败
                                    $res['msg'] = $rescurl[1];
                                    $res['flag'] = false;
                                    echo json_encode($res);
                                    exit();
                                }

                                $device_update = ytapi187_inset("UPDATE device set deviceType='" . $Data['deviceType'] . "',name='" . $Data['device_name'] . "',manufacturerName=
                                '" . $Data['manufacturerName'] . "',model='" . $Data['model'] . "',isSecure='" . $Data['isSecure'] . "',manufacturerId='" . $Data['manufacturerId'] . "',
                                protocolType='" . $Data['protocolType'] . "',location='" . $Data['location'] . "',updatetime='" . date('Y-m-d H:i:s') . "' where device_id=
                                '" . $Data['device_code'] . "'");
                                $device_query = ytapi187_query("select * from device where device_id='" . $Data['device_code'] . "'");
                                $device_id = $device_query[0]['device_id'];
                                $deviceType = $Data['deviceType'];
                                $create_sql = addtable($device_id, $deviceType);
                                $table = Db::execute($create_sql);
                                $deviceStatus = M()->query("SELECT statustime FROM sp_devices_status WHERE deviceid = '" . $device_query[0]['device_id'] . "'");
                                if (!$deviceStatus) {
                                    $data6['deviceid'] = $device_query[0]['device_id'];
                                    $data6['deviceno'] = 0;
                                    $data6['devicestatus'] = '75';
                                    $data6['statustime'] = date('Y-m-d H:i:s');
                                    $data6['f_evt'] = 40;
                                    $data6['c_evt'] = 00;
                                    $data6['w_evt'] = "";
                                    $data6['true_status'] = '75';
                                    $data6['lastcommtime'] = '0';
                                    $Res2 = M('devices_status')->add($data6);
                                }
                                if ($Data['company_code']) {
                                    $Res1 = M('owner')->add($data);
//                                  $Res2 = M('devices_status')->add($data1);
                                    $Res3 = M('object_share')->add($data2);
                                }
                                if ($device_update) {
                                    $res['msg'] = "操作成功";
                                    $res['flag'] = true;
                                    echo json_encode($res);
                                    exit();
                                } else {
                                    $res['msg'] = "添加失败，请稍后再试";
                                    $res['flag'] = false;
                                    echo json_encode($res);
                                    exit();
                                }


                            } else {
                                $res['msg'] = "添加失败，请稍后再试";
                                $res['flag'] = false;
                                echo json_encode($res);
                                exit();
                            }
                        } else {
                            $res['msg'] = '该设备编号已经添加';
                            $res['flag'] = false;
                            echo json_encode($res);
                            exit();
                        }
                        break;
                    case 'Lora':
                        $url = "https://ttl.turboes.com/api/api/login";
                        $parameter = [
                            "appKey" => "wLHvcVHS",
                            "appSecret" => "a9daf060059d205280646a1880cd1fc24f3c5c69"
                        ];
                        $accessToken = json_post($url, $parameter);
                        $accessToken_array = json_decode($accessToken, true);

                        if ($accessToken_array['code'] == 200) {
                            $url1 = "https://ttl.turboes.com/api/ttl/api/v1/device?access_token=" . $accessToken_array['data']['token'];

                            if ($Data['platfromProtocolType'] == 1) {
                                $parameter1 = [
                                    "nodeId" => $Data['device_code'],
                                    "nodeName" => $Data['device_name'],
                                    "appKey" => "nIeDYZ3ufbV3bBoC ",
                                    "platfromProtocolType" => $Data['platfromProtocolType'],
                                    "platfromId" => $Data['platfromId'],
                                    "productKey" => $Data['productKey'],
                                    "protocol_NB" => [
                                        "nodeName" => $Data['device_code']
                                    ]
                                ];
                            } else {
                                $parameter1 = [
                                    "nodeId" => $Data['device_code'],
                                    "nodeName" => $Data['device_name'],
                                    "appKey" => "nIeDYZ3ufbV3bBoC ",
                                    "platfromProtocolType" => $Data['platfromProtocolType'],
                                    "platfromId" => $Data['platfromId'],
                                    "productKey" => $Data['productKey'],
                                    "protocol_LORA" => [
                                        "devEui" => $Data['devEui'],
                                        "region" => $Data['region'],
                                        "activationType" => $Data['activationType'],
                                        "AppKey" => $Data['AppKey'],
                                        "NwkSKey" => $Data['NwkSKey'],
                                        "AppSKey" => $Data['AppSKey'],
                                        "DevAddr" => $Data['DevAddr']
                                    ]
                                ];
                            }

//                            print_r(json_encode($parameter1));
//                            exit();
                            $R = json_post($url1, $parameter1);
                            $R1 = json_decode($R, true);
                            if ($R1['code'] == 200) {
                                $Res1 = M('owner')->add($data);
                                $Res2 = M('devices_status')->add($data1);
                                $Res3 = M('object_share')->add($data2);
                            } else {
                                $res['msg'] = $accessToken_array['message'];
                                $res['flag'] = false;
                                echo json_encode($res);
                                exit();
                            }
                        } else {
                            $res['msg'] = $accessToken_array['message'];
                            $res['flag'] = false;
                            echo json_encode($res);
                            exit();
                        }

                        break;
                    case '4G':
                        $Res1 = M('owner')->add($data);
                        $Res2 = M('devices_status')->add($data1);
                        $Res3 = M('object_share')->add($data2);
                        break;
                    default:
                        $res['msg'] = '操作失败，该传输方式不存在，请联系管理员';
                        $res['flag'] = false;
                        echo json_encode($res);
                        exit();
                }
                break;
            case '4'://消防栓
                $data2['dwtype'] = 'YTFH';
                $Res1 = M('owner')->add($data);
                $Res2 = M('devices_status')->add($data1);
                $Res3 = M('object_share')->add($data2);
                break;
            case '5'://液位
                $data2['dwtype'] = 'YTLL';
                $data2['start_port'] = '0';
                $data2['rec_cur'] = '0';
                $Res = M()->query("SELECT max(object_code) AS object_code FROM sp_object_share WHERE object_code LIKE '" . $data2['dwtype'] . "-" . $Data['company_code'] . "%'");
                if (empty($Res)) {
                    $data2['object_code'] = $data2['dwtype'] . '-' . $Data['company_code'] . '001';
                } else {
                    $sort = (int)substr($Res[0]['object_code'], 10, 3) + 1;
                    $num = str_pad($sort, 3, "0", STR_PAD_LEFT);
                    $data2['object_code'] = $data2['dwtype'] . '-' . $Data['company_code'] . $num;
                }
                switch ($data['transfer_type']) {
                    case 'NB':
                        if (empty($data3['deviceType']) || empty($data3['manufacturerName']) || empty($data3['model']) || empty($data3['location']) || empty($data3['protocolType'])) {
                            $res['msg'] = "请填写好必要内容";
                            $res['flag'] = false;
                            echo json_encode($res);
                            exit();
                        }
                        $R = ytapi187_query("select * from device where device_id='" . $Data['device_code'] . "'");
                        if (empty($R)) {
                            if (empty($Data['device_code']) || empty($Data['device_name'])) {
                                $res['msg'] = '请填写好必要内容';
                                $res['flag'] = false;
                                echo json_encode($res);
                                exit();
                            }

                            $token = json_decode(gettoken(), true);
                            $sendata = [
                                "verifyCode" => $Data['device_code'],//"868744030067098"
                                "nodeId" => $Data['device_code'],
                                "timeout" => 0
                            ];

                            $header = [
                                "Content-Type:application/json",
                                "app_key:" . $this->appId,
                                "Authorization:Bearer " . $token["accessToken"]
                            ];

                            $rescurl = curl($this->host . "iocm/app/reg/v1.1.0/deviceCredentials?appId=" . $this->appId, json_encode($sendata), $header);
                            if ($rescurl[0] == 200) {
                                $res1 = json_decode($rescurl[1], true);
                            } else {
                                $res['msg'] = $rescurl;
                                $res['flag'] = false;
                                echo json_encode($res);
                                exit();
                            }
                            $list = array();
                            $list['device_id'] = trim($Data['device_code']);
                            $list['name'] = $Data['device_name'];
                            $list['iot_id'] = $res1['deviceId'];
                            $list['psk'] = $res1['psk'];
                            $list['addtime'] = date('Y-m-d H:i:s');
                            $list['updatetime'] = date('Y-m-d H:i:s');
                            $device_table = "dev_" . $Data['device_code'];
                            $create_sql = "
                            CREATE TABLE `" . $device_table . "` (
                              `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
                              `device_id` varchar(200) DEFAULT NULL,
                              `iot_id` varchar(255) DEFAULT NULL,
                              `service` text,
                              `addtime` varchar(50) DEFAULT NULL,
                              `notifyType` varchar(50) DEFAULT NULL,
                              PRIMARY KEY (`id`)
                            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

                            ytapi187_inset($create_sql);

                            $rs = ytapi187_inset("INSERT INTO device (device_id,name,addtime,updatetime,iot_id,psk,manufacturerId,manufacturerName,deviceType
                                ,model,location,isSecure,status,protocolType,owner_id) values ('" . $list['device_id'] . "','" . $list['name'] . "','" . $list['addtime'] . "',
                                '" . $list['updatetime'] . "','" . $list['iot_id'] . "','" . $list['psk'] . "','','','','','','','','','')");
                            if ($rs) {
                                $owner1 = M()->query("SELECT company,louyu,unitinfo FROM sp_owner WHERE owner_code = '" . $Data['device_code'] . "'");
                                if ($owner1) {
                                    $data4['owner_name'] = $Data['device_name'];
                                    $data4['unitinfo'] = $Data['unitinfo'];
                                    $data4['louyu'] = $Data['louyu'];
                                    $data4['company'] = $Data['company_code'];
                                    $where4['owner_code'] = $Data['device_code'];
                                    $res4 = M('owner')->where($where4)->save($data4);
                                } else {
                                    $token = json_decode(gettoken(), true);
                                    $sendata = [
                                        "name" => $Data['device_code'],
                                        "deviceType" => $Data['deviceType'],
                                        "manufacturerName" => $Data['manufacturerName'],
                                        "manufacturerId" => $Data['manufacturerId'],//厂商ID ST、ZHYQ、JunyanTest、Topsail
                                        "model" => $Data['model'],
                                        "protocolType" => $Data['protocolType'],
                                        "location" => trim($Data['location'])
                                    ];
                                    $header = [
                                        "Content-Type:application/json",
                                        "app_key:" . $this->appId,
                                        "Authorization:Bearer " . $token["accessToken"]
                                    ];
                                    $rescurl = curl($this->host . "iocm/app/dm/v1.4.0/devices/" . $list['iot_id'] . "?appId=" . $this->appId, json_encode($sendata, 320), $header, "PUT");
                                }
                                if ($rescurl[0] == 204) {//成功
                                    $res1 = json_decode($rescurl[1], true);
                                } else {//失败
                                    $res['msg'] = $rescurl[1];
                                    $res['flag'] = false;
                                    echo json_encode($res);
                                    exit();
                                }

                                $device_update = ytapi187_inset("UPDATE device set deviceType='" . $Data['deviceType'] . "',name='" . $Data['device_name'] . "',manufacturerName=
                                '" . $Data['manufacturerName'] . "',model='" . $Data['model'] . "',isSecure='" . $Data['isSecure'] . "',manufacturerId='" . $Data['manufacturerId'] . "',
                                protocolType='" . $Data['protocolType'] . "',location='" . $Data['location'] . "',updatetime='" . date('Y-m-d H:i:s') . "' where device_id=
                                '" . $Data['device_code'] . "'");
                                $device_query = ytapi187_query("select * from device where device_id='" . $Data['device_code'] . "'");
                                $device_id = $device_query[0]['device_id'];
                                $deviceType = $Data['deviceType'];
                                $create_sql = addtable($device_id, $deviceType);
                                $table = Db::execute($create_sql);
                                $deviceStatus = M()->query("SELECT statustime FROM sp_devices_status WHERE deviceid = '" . $device_query[0]['device_id'] . "'");
                                if (!$deviceStatus) {
                                    $data6['deviceid'] = $device_query[0]['device_id'];
                                    $data6['deviceno'] = 0;
                                    $data6['devicestatus'] = '75';
                                    $data6['statustime'] = date('Y-m-d H:i:s');
                                    $data6['f_evt'] = 40;
                                    $data6['c_evt'] = 00;
                                    $data6['w_evt'] = "";
                                    $data6['true_status'] = '75';
                                    $data6['lastcommtime'] = '0';
                                    $Res2 = M('devices_status')->add($data6);
                                }
                                if ($Data['company_code']) {
                                    $Res1 = M('owner')->add($data);
//                                    $Res2 = M('devices_status')->add($data1);
                                    $Res3 = M('object_share')->add($data2);
                                }
                                if ($device_update) {
                                    $res['msg'] = "操作成功";
                                    $res['flag'] = true;
                                    echo json_encode($res);
                                    exit();
                                } else {
                                    $res['msg'] = "添加失败，请稍后再试";
                                    $res['flag'] = false;
                                    echo json_encode($res);
                                    exit();
                                }


                            } else {
                                $res['msg'] = "添加失败，请稍后再试";
                                $res['flag'] = false;
                                echo json_encode($res);
                                exit();
                            }
                        } else {
                            $res['msg'] = '该设备编号已经添加';
                            $res['flag'] = false;
                            echo json_encode($res);
                            exit();
                        }
                        break;
                    case 'Lora':
                        $a = '';
                        break;
                    case '4G':
                        $Res1 = M('owner')->add($data);
                        $Res2 = M('devices_status')->add($data1);
                        $Res3 = M('object_share')->add($data2);
                        break;
                    default:
                        $res['msg'] = '操作失败，该传输方式不存在，请联系管理员';
                        $res['flag'] = false;
                        echo json_encode($res);
                        exit();
                }
                break;
            case '6'://RTU
                $Res1 = M('owner')->add($data);
                $Res2 = M('devices_status')->add($data1);
                break;
            case '7'://电气火灾
                $data2['dwtype'] = 'YTEF';
                $data2['min_level'] = $Data['min_level'];
                $data2['max_level'] = $Data['max_level'];
                $Res1 = M('owner')->add($data);
                $Res2 = M('devices_status')->add($data1);
                $Res3 = M('object_share')->add($data2);
                break;
            case '16'://视频监测
                $data2['dwtype'] = 'YTVA';
                $Res1 = M('owner')->add($data);
                $Res2 = M('devices_status')->add($data1);
                $Res3 = M('object_share')->add($data2);
                break;
            case '17'://电梯监测
                $data2['dwtype'] = 'YTLF';
                $Res1 = M('owner')->add($data);
                $Res2 = M('devices_status')->add($data1);
                $Res3 = M('object_share')->add($data2);
                break;
            case '128'://井盖
                $data2['dwtype'] = 'YTMC';
                $Res1 = M('owner')->add($data);
                $Res2 = M('devices_status')->add($data1);
                $Res3 = M('object_share')->add($data2);
                break;
            case '129'://地磁
                $Res1 = M('owner')->add($data);
                $Res2 = M('devices_status')->add($data1);
                break;
            case '130'://门禁
                $Res1 = M('owner')->add($data);
                $Res2 = M('devices_status')->add($data1);
                break;
            case '131'://可燃气体
                $Res1 = M('owner')->add($data);
                $Res2 = M('devices_status')->add($data1);
                break;
            default:
                $res['msg'] = '操作失败，设备类型尚未定义，请联系管理员';
                $res['flag'] = false;
                echo json_encode($res);
                exit();
                break;
        }

        if ($Res1) {
            $res['msg'] = '操作成功';
            $res['flag'] = true;
            echo json_encode($res);
        } else {
            $res['msg'] = '操作失败';
            $res['flag'] = true;
            echo json_encode($res);
        }
    }

    public function getNbApplicationList()
    {
        $url = "https://ttl.turboes.com/api/api/login";
        $parameter = [
            "appKey" => "wLHvcVHS",
            "appSecret" => "a9daf060059d205280646a1880cd1fc24f3c5c69"
        ];
        $accessToken = json_post($url, $parameter);
        $accessToken_array = json_decode($accessToken, true);
//        print_r($accessToken_array);

        if ($accessToken_array['code'] == 200) {
            $url = "https://ttl.turboes.com/api/ttl/api/v1/app?access_token=" . $accessToken_array['data']['token'];
//            $parameter=[
//                "access_token" => $accessToken_array['data']['token']
//            ];
//            print_r(json_encode($parameter));

            $R = curl_get($url);

            $R1 = json_decode($R, true);
            if ($R1['code'] == 200) {
                $res['msg'] = "操作成功";
                $res['data'] = $R1['data'];
                $res['flag'] = true;
                echo json_encode($res);
            } else {
                $res['msg'] = $R1['message'];
                $res['flag'] = false;
                echo json_encode($res);
                exit();
            }
        } else {
            $res['msg'] = $accessToken_array['message'];
            $res['flag'] = false;
            echo json_encode($res);
            exit();
        }
    }

    public function setPortConfig()
    {
        $Data = I("");
        $Res = M()->query("SELECT max(object_code) AS object_code FROM sp_object_share WHERE object_code LIKE '" . $Data['dwtype'] . "-" . $Data['company_code'] . "%'");
        if (empty($Res)) {
            $data['object_code'] = $Data['dwtype'] . '-' . $Data['company_code'] . '001';
        } else {
            $sort = (int)substr($Res[0]['object_code'], 10, 3) + 1;
            $num = str_pad($sort, 3, "0", STR_PAD_LEFT);
            $data['object_code'] = $Data['dwtype'] . '-' . $Data['company_code'] . $num;
        }
        $data['owner_code'] = $Data['owner_code'];
        $data['owner_dwtype'] = 6;
        $data['dwtype'] = $Data['dwtype'];
        $data['device_name'] = $Data['device_name'];
        $data['object_name'] = $Data['object_name'];
        $data['start_port'] = $Data['ports'];
        $data['rec_cur'] = 0;
        $data['min_level'] = $Data['floor'];
        $data['max_level'] = $Data['floor'];
        $data['is_top'] = $Data['is_top'];
        $R1 = M()->query("select * from sp_owner_port where owner_code='" . $Data['owner_code'] . "' and iotype=" . $Data['iotype'] . " and ports='" . $Data['ports'] . "'");
        if (!empty($R1[0]['id'])) {
            $R = M('owner_port')->where(array('id' => $R1[0]['id']))->save($Data);
        } else {
            $R = M('owner_port')->add($Data);
//            print_r($data);
            $Res3 = M('object_share')->add($data);
//            print_r($Res3);

        }
        if ($R) {
            $res['msg'] = "操作成功";
            $res['flag'] = true;
            echo json_encode($res);
        } else {
            $res['msg'] = "操作失败";
            $res['flag'] = false;
            echo json_encode($res);
        }

    }

    public function delPort()
    {
        $Data = I();
        if (!empty($Data['id'])) {

            $Res = M()->query("SELECT * FROM sp_object_share WHERE owner_code = '" . $Data['owner_code'] . "'");
            $S = M('object_share')->delete($Res[0]['id']);
            $R = M('owner_port')->delete($Data['id']);
            if ($R) {
                $res['msg'] = "操作成功";
                $res['flag'] = true;
                echo json_encode($res);
            } else {
                $res['msg'] = "操作失败";
                $res['flag'] = false;
                echo json_encode($res);
            }
        }
    }


    public function getDeviceListEcho()
    {
        $Data = I();
        $device_code=$Data['device_code'];
        $RES=M()->query("select * from sp_owner where owner_code='".$device_code."'");
        $RES1=M()->query("select * from sp_object_share where owner_code='".$device_code."'");
        $data[0]['id']=$RES[0]['id'];
        $data[0]['owner_code']=$RES[0]['owner_code'];
        $data[0]['owner_name']=$RES[0]['owner_name'];
        $data[0]['unitinfo']=$RES[0]['unitinfo'];
        $data[0]['louyu']=$RES[0]['louyu'];
        $data[0]['company']=$RES[0]['company'];
        $data[0]['transfer_type']=$RES[0]['transfer_type'];
        $data[0]['owner_bl']=$RES[0]['owner_bl'];
        $data[0]['sim']=$RES[0]['sim'];
        $data[0]['dwtype']=$RES[0]['dwtype'];

        if ($RES[0]['dwtype']==1){
            if (!empty($RES[0]['dwtype'])){
                $owner_xh = explode(",", $RES[0]['owner_xh']);
                $owner_xh1=str_split($owner_xh[1]);
                $data[0]['owner_xh_a']=$owner_xh1[0];
                $data[0]['owner_xh_b']=$owner_xh1[1];
                $data[0]['owner_xh_c']=$owner_xh1[2];
            }else{
                $data[0]['owner_xh_a']="";
                $data[0]['owner_xh_b']="";
                $data[0]['owner_xh_c']="";
            }
        }else{
            $data[0]['owner_xh_a']="";
            $data[0]['owner_xh_b']="";
            $data[0]['owner_xh_c']="";
        }
        $data[0]['min_level']=$RES1[0]['min_level'];
        $data[0]['max_level']=$RES1[0]['max_level'];
        $data[0]['is_top']=$RES1[0]['is_top'];

        $res['msg'] = "操作成功";
        $res['flag'] = true;
        $res['data'] = $data;
        echo json_encode($res);
    }

    public function upDevice(){
        $Data = I();
        if (isset($Data['device_code'])&&!empty($Data['device_code'])){
            $device_code=$Data['device_code'];
        }else{
            $res['msg'] = "操作失败，缺少重要参数device_code";
            $res['flag'] = false;
            echo json_encode($res);
            exit();
        }

        if (isset($Data['owner_name'])&&!empty($Data['owner_name'])){
            $data['owner_name']=$Data['owner_name'];
            $data1['device_name']=$Data['owner_name'];
        }
        if (isset($Data['unitinfo'])&&!empty($Data['unitinfo'])){
            $data['unitinfo']=$Data['unitinfo'];
            $data1['object_name']=$Data['unitinfo'];
        }
        if (isset($Data['louyu'])&&!empty($Data['louyu'])){
            $data['louyu']=$Data['louyu'];
        }
        if (isset($Data['transfer_type'])&&!empty($Data['transfer_type'])){
            $data['transfer_type']=$Data['transfer_type'];
        }
        if (isset($Data['owner_bl'])&&!empty($Data['owner_bl'])){
            $data['owner_bl']=$Data['owner_bl'];
        }
        if (isset($Data['sim'])&&!empty($Data['sim'])){
            $data['sim']=$Data['sim'];
        }
//        print_r($Data);

        if (isset($Data['owner_xh_a'])&&isset($Data['owner_xh_b'])&&isset($Data['owner_xh_c'])){
            $data['owner_xh'] = '0,' . $Data['owner_xh_a'] . $Data['owner_xh_b'] . $Data['owner_xh_c'];
//            print_r($data['owner_xh']);
        }
//        exit();
        if (isset($Data['min_level'])&&!empty($Data['min_level'])){
            $data1['min_level']=$Data['min_level'];
        }
        if (isset($Data['max_level'])&&!empty($Data['max_level'])){
            $data1['max_level']=$Data['max_level'];
        }
        if (isset($Data['is_top'])){
            $data1['is_top']=$Data['is_top'];
        }

//        $data[0]['company']=$Data['company'];
//        $data[0]['dwtype']=$Data['dwtype'];
        $where['owner_code']=$device_code;
        if (!empty($where)&&!empty($data)){
            $status = M('owner')->where($where)->save($data);
        }

        if (!empty($where)&&!empty($data1)){
            $status1 = M('object_share')->where($where)->save($data1);
        }

        if ($status||$status1){
            $res['msg'] = "操作成功";
            $res['flag'] = true;
            echo json_encode($res);
        }else{
            $res['msg'] = "操作失败";
            $res['flag'] = false;
            echo json_encode($res);
        }

    }

}

