<?php

namespace Home\Controller;

use Think\Cache\Driver;
use Think\Controller;

class FirewarnController extends PushWarnController
{
    /**
     * 用传告警推送
     */
    public function message_sendalarm()
    {
        $Data = I();
        //日志打印
        $filename_log = "/var/www/html/jdxf/log/hj_log" . date("Y-m-d") . ".log";
        $this->printing_log($Data, $filename_log, '用传', '参数');
        //参数获取
        $device_code = $this->getDeviceCode($Data);
        $insert_id = $Data['insert_id'];
        $time = $Data['time'];
        $remark = $Data['bz'];
        $unique_number = null;
        $astrict = M("fire_backup")->where(['device_code' => $device_code])->count();
        if ($astrict > 0) {
            echo '该设备做限制，不进行推送';
            exit();
        }
        //设备基础信息查询1
        $device_data = M()->query("select s.owner_name,s.unitinfo,s.company,c.owner_address,s.dwtype from sp_owner s ,sp_owner_company c where s.company=c.owner_id and s.owner_code ='" . $device_code . "'");
        if (count($device_data) == 0) {
            echo '设备信息错误！';
            exit;
        }
        //判断是否报备和3小时以内相同设备报警未处理则不推送
        $this->redisShieldAlarm($device_data[0]['company'], $device_data[0]['dwtype'], $device_code, $time, $insert_id, $unique_number);
        //where条件和状态的判定
        $status_data = $this->getAlarmStatus($Data['types']);
        //设备基础信息查询
        $phone_data = M()->query("select phone from sp_owner_phone  WHERE owner_code='" . $device_data[0]['company'] . "' " . $status_data['where'] . "  and statusbb=1");
        if (count($phone_data) == 0) {
            echo 'phone is null';
            exit;
        }
        $phone = $this->array_column1($phone_data, "phone");
        $time_data = M()->query("SELECT statustime FROM sp_devices_status where deviceid='" . $device_code . "'");
        $op = M()->query("SELECT openid FROM sp_wx_opuser WHERE status=1 and type='wx' and idphone in($phone)");
        $access_token = GetAccess_Token1();
        $address = '警报地址：' . $device_data[0]['owner_address'] . $device_data[0]['unitinfo'];
        if (empty($time)) {
            $time = $time_data[0]['statustime'];
        }
        if (empty($remark)) {
            $remark = '设备名称：' . $device_data[0]['owner_name'];
        }
        $url = "https://qhome.usky.cn/work/#/pages/proceDetailEle1/proceDetailEle1?type=1&id=" . $insert_id;
//        $url = "https://qhome.usky.cn/jdxf/wxapp2.php/Home/Fireinfo/index/type/1/id/" . $id;
        foreach ($op as $o) {
            if (!empty($o['openid'])) {
                $a = $this->SendDeviceAlarm($access_token, $o['openid'], $address, $device_code, $status_data['status'], $time, $remark, $url);
                //日志打印
                $this->printing_log($a, $filename_log, '用传', '返回');
            }
        }
    }

//测试
    function xxxx()
    {
        $access_token = GetAccess_Token1();
        $data = array(
            "touser" => 'o83OY1ctQP1pVo7zCWtjCsXzK-Ok',
            "template_id" => "xJPLfWkpjUZlrumL5sgYbOfauAP3nqdSumqlGE5IsGg",
            "url" => "http://zt-iot.com/ztcrm/index.php/home/Warnlist/index2/code_id/1/uid/install_id/types/1",
            "data" => array(
                "first" => array(
                    "value" => '',
                    "color" => "#44b549"
                ),
                "keyword1" => array(
                    "value" => '未解析',
                    "color" => "#173177"
                ),
                "keyword2" => array(
                    "value" => '',
                    "color" => "#173177"
                ),
                "keyword3" => array(
                    "value" => date('Y-m-d H:i:s'),
                    "color" => "#173177"
                ),
                "remark" => array(
                    "value" => '',
                    "color" => "#aaaaaa"
                )
            )
        );
        $data = json_encode($data);
        $QUEST_URL = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=" . $access_token;
        $res = $this->curl($QUEST_URL, $data);
        return json_decode($res, true);
    }

}