<?php

namespace Home\Controller;

use Think\Controller;
use Think\Cache\Driver;


class AlarmReportController extends ComController
{
    //告警报备列表查询
    public function index()
    {
        $Data = I();
        $where = "";
        $limit = "";
        if(!empty($Data['start_time']) && !empty($Data['end_time'])){
            $where=" and add_time between '".$Data['start_time']."' and '".$Data['end_time']."' ";
        }

        if(!empty($Data['pages']) && !empty($Data['size'])){
//            print_r($Data['pages']);
            $start_limit = ((int)$Data['pages'] - 1) * $Data['size'];
            $limit=" LIMIT ".$start_limit.",".$Data['size'];

        }
        $where1['company_code'] = $Data['company_code'];
        $where1['report_status'] = 1;
        $res_count = M("wc_alarm_report")->where($where1)->count();
//        print_r("SELECT * FROM sp_wc_alarm_report WHERE company_code='" . $Data['company_code'] . "' and report_status=1 ".$where." order by id desc".$limit);
        $res = M()->query("SELECT * FROM sp_wc_alarm_report WHERE company_code='" . $Data['company_code'] . "' and report_status=1 ".$where." order by id desc".$limit);
        foreach ($res as $key=>$value){
            if ($res[$key]['report_type']==1){
                $res[$key]['report_name']='单位告警报备';
            }else if ($res[$key]['report_type']==2){
                $res[$key]['report_name']='类型告警报备';
            }else if ($res[$key]['report_type']==3){
                $res[$key]['report_name']='设备告警报备';
            }else{
                $res[$key]['report_name']='未定义告警报备';
            }
        }
        $R['msg'] = '操作成功';
        $R['flag'] = true;
        $R['totalcount'] = $res_count;
        $R['data'] = $res;
        echo json_encode($R);
    }

    //告警报备新增
    public function add()
    {
        $Data = I();
        $Data['report_type'] = empty($Data['report_type']) ? 0 : $Data['report_type'];
        $Data['company_code'] = empty($Data['company_code']) ? "00000" : $Data['company_code'];
        $Data['device_type'] = empty($Data['device_type']) ? "000" : $Data['device_type'];
        $Data['device_code'] = empty($Data['device_code']) ? "000000000000000" : $Data['device_code'];
        $Data['port_type'] = empty($Data['port_type']) ? "0" : $Data['port_type'];
        $Data['device_port'] = empty($Data['device_port']) ? "00" : $Data['device_port'];
        $Data['add_time'] = date('Y-m-d H:i:s', time());
        $Data['remarks'] = empty($Data['remarks']) ? "" : $Data['remarks'];
        $arr=$this->arraySplicing($Data);
        $res = M("wc_alarm_report")->add($Data);
        $this->redisAdd($arr['unique_number'],$arr['value'],"新增");
        if (!empty($res)&&$res!=0){
            $R['msg'] = '操作成功';
            $R['flag'] = true;
            $R['data'] = "";
            echo json_encode($R);
        }else {
            $R['msg'] = '操作失败';
            $R['flag'] = false;
            $R['data'] = "";
            echo json_encode($R);
        }
    }

    //设备数据下拉列表
    public function deviceList()
    {
        $Data = I();
        $where['company'] = $Data['company_code'];
        $where['dwtype'] = $Data['device_type'];
        $res = M("owner")->where($where)->select();
        $R['msg'] = '操作成功';
        $R['flag'] = true;
        $R['data'] = $res;
        echo json_encode($R);
    }

    //修改回显
    public function editData()
    {
        $Data = I();
        $res = M()->query("SELECT * FROM sp_wc_alarm_report WHERE id='" . $Data['id'] . "' and report_status=1");
        foreach ($res as $key=>$value){
            if ($res[$key]['report_type']==1){
                $res[$key]['report_name']='单位告警报备';
            }else if ($res[$key]['report_type']==2){
                $res[$key]['report_name']='类型告警报备';
            }else if ($res[$key]['report_type']==3){
                $res[$key]['report_name']='设备告警报备';
            }else{
                $res[$key]['report_name']='未定义告警报备';
            }
        }
        $R['msg'] = '操作成功';
        $R['flag'] = true;
        $R['data'] = $res;
        echo json_encode($R);
    }

    public function edit()
    {
        $Data = I();
        $arr=$this->arraySplicing($Data);
        $where['id'] = $Data['id'];
        $redis_data = M("wc_alarm_report")->where($where)->find();
        $res = M("wc_alarm_report")->where($where)->save($Data);
        $this->redisEdit($arr['unique_number'],$arr['value'],$redis_data,"编辑");
        if ($res){
            $R['msg'] = '操作成功';
            $R['flag'] = true;
            $R['data'] = "";
            echo json_encode($R);
        }else{
            $R['msg'] = '操作失败';
            $R['flag'] = false;
            $R['data'] = "";
            echo json_encode($R);
        }
    }

    public function del()
    {
        $Data = I();
        $where['id'] = $Data['id'];
        $data['report_status'] = 0;
        $res = M("wc_alarm_report")->where($where)->save($data);
        $r = M("wc_alarm_report")->where($where)->find();
        $unique_number = $r['company_code'] . '_' . $r['device_type'] . '_' . $r['device_code'] . '_' .$r['port_type'] . '_' . $r['device_port'];
        $this->redisDel($unique_number,$r,"删除");
        if ($res){
            $R['msg'] = '操作成功';
            $R['flag'] = true;
            $R['data'] = "";
            echo json_encode($R);
        }else{
            $R['msg'] = '操作成功';
            $R['flag'] = false;
            $R['data'] = "";
            echo json_encode($R);
        }
    }


    //Redis缓存数据储存
    public function redisAdd($unique_number, $value, $type)
    {
        $redis = new \Redis();
        $result = $redis->connect('47.98.201.73', 6379);
        $redis->auth("usky2021");
        $redis->select(2);
        if ($result == 1) {
            $redis->set("$unique_number", "$value");
            $redis->close();
        } else {
            $data[$unique_number] = $value;
            $data["msg"] = "redis连接失败，" . $type . "数据丢失";
            $this->redisReportLog($data);
        }
    }
    //Redis缓存数据储存
    public function redisEdit($unique_number, $value,$redis_data,$type)
    {
        $redis = new \Redis();
        $result = $redis->connect('47.98.201.73', 6379);
        $redis->auth("usky2021");
        $redis->select(2);
        if ($result == 1) {
            $time_data=explode('_', $redis->get($unique_number));
            if ($time_data[0]==$redis_data['start_time']&&$time_data[1]==$redis_data['end_time']){
                $redis->set($unique_number, "$value");
            }
            $redis->close();
        } else {
            $data[$unique_number] = $value;
            $data["msg"] = "redis连接失败，" . $type . "数据丢失";
            $this->redisReportLog($data);
        }
    }

    //Redis缓存数据清除
    public function redisDel($unique_number,$r, $type)
    {
        $redis = new \Redis();
        $result = $redis->connect('47.98.201.73', 6379);
        $redis->auth("usky2021");
        $redis->select(2);
        if ($result == 1) {
            $time_data=explode('_', $redis->get($unique_number));
            if ($time_data[0]==$r['start_time']&&$time_data[1]==$r['end_time']){
                $redis->del($unique_number);
            }
            $redis->close();
        } else {
            $data['unique_number'] = $unique_number;
            $data["msg"] = "redis连接失败，" . $type . "数据删除失败";
            $this->redisReportLog($data);
        }
    }

    //日志打印
    public function redisReportLog($Data)
    {
        $log = "[时间" . date("Y-m-d H:i:s") . "]数据：" . json_encode($Data, JSON_UNESCAPED_UNICODE) . "\r\n";
        $filename_log = "/var/www/html/jdxf/log/redis_report_log" . date("Y-m-d") . ".log";
        file_put_contents($filename_log, $log, FILE_APPEND | LOCK_EX);
    }

    public function arraySplicing($Data){
        $company_code = empty($Data['company_code']) ? "00000" : $Data['company_code'];
        $device_type = empty($Data['device_type']) ? "000" : $Data['device_type'];
        $device_code = empty($Data['device_code']) ? "000000000000000" : $Data['device_code'];
        $port_type = empty($Data['port_type']) ? "0" : $Data['port_type'];
        $device_port = empty($Data['device_port']) ? "00" : $Data['device_port'];
        $start_time = empty($Data['start_time']) ? "0000-00-00 00:00:00" : $Data['start_time'];
        $end_time = empty($Data['end_time']) ? "0000-00-00 00:00:00" : $Data['end_time'];
        $unique_number = $company_code . '_' . $device_type.'_'.$device_code.'_'.$port_type.'_'.$device_port;
        $value = $start_time . '_' . $end_time;
        $res['unique_number'] = $unique_number;
        $res['value'] = $value;
        return $res;
    }
}