<?php

namespace Home\Controller;

use Think\Cache\Driver;
use Think\Controller;

include '../Common/function.php';

class GaswarnController extends PushWarnController
{

    //可燃气体告警推送
    public function message_gas()
    {
        $Data = I('post.');
        //日志打印
        $filename_log = "/var/www/html/jdxf/log/gas_b_log" . date("Y-m-d") . ".log";
        $this->printing_log($Data, $filename_log, '可燃气体', '参数');
        //获取参数
        $device_code = $this->getDeviceCode($Data);
        $unique_number = $device_code;
        $insert_id = $Data['insert_id'];
        $remarks = $Data['bz'];
        $time = $Data['time'];
        $evt = $Data['evt'];
        //设备基础信息查询1
        $device_data = M()->query("select s.owner_name,s.unitinfo,s.company,c.owner_address,s.dwtype from sp_owner s ,sp_owner_company c where s.company=c.owner_id and s.owner_code ='" . $device_code . "'");
        if (count($device_data) == 0) {
            echo '设备信息错误！';
            exit;
        }
        //判断是否报备和3小时以内相同设备报警未处理则不推送
        $this->redisShieldAlarm($device_data[0]['company'], $device_data[0]['dwtype'], $device_code, $time, $insert_id, $unique_number);
        //where条件和状态的判定
        $status_data = $this->getAlarmStatus($evt);
        $union_sql = M()->query("select phone from sp_owner_phone  WHERE owner_code='" . $device_data[0]['company'] . "' " . $status_data['where']);
        if (count($union_sql) == 0) {
            echo "phone is null";
            exit;
        }
        $openids = $this->array_column1($union_sql, "phone");
        $time_data = M()->query("SELECT statustime FROM sp_devices_status where deviceid='" . $device_code . "'");
        $op = M()->query("SELECT openid FROM sp_wx_opuser status=1 and WHERE type='wx' and idphone in($openids)");
        $access_token = GetAccess_Token1();
        $address = '警报地址：' . $device_data[0]['owner_address'] . $device_data[0]['unitinfo'];
        if (empty($time)) {
            $time = $time_data[0]['statustime'];
        }
        if (empty($remarks)) {
            $remarks = '设备名称：' . $device_data[0]['owner_name'];
        }
        $url = "https://iot.usky.cn/jdxf/wxapp2.php/Home/Fireinfo/index/type/131/id/" . $insert_id;
        foreach ($op as $o) {
            if (!empty($o['openid'])) {
                $R = $this->SendDeviceAlarm($access_token, $o['openid'], $address, $device_code, $status_data['status'], $time, $remarks, $url);
                $this->printing_log($R, $filename_log, '可燃气体', '返回');
            }
        }


    }
}