<?php

namespace Home\Controller;

use Think\Cache\Driver;
use Think\Controller;

class RtuwarnController extends PushWarnController
{
    /**
     * RTU告警推送
     */
    public function message_sendalarm()
    {
        $Data = I();
        //日志打印
        $filename_log = "/var/www/html/jdxf/log/rtu_log" . date("Y-m-d") . ".log";
        $this->printing_log($Data, $filename_log, 'RTU', '参数');
        //参数获取
        $device_code = $this->getDeviceCode($Data);
        $insert_id = $Data['insert_id'];
        $time = $Data['time'];
        $remark = $Data['bz'];
        $unique_number = $Data['unique_number'] . $Data['types'];
        //设备基础信息查询1
        $device_data = M()->query("select s.owner_name,s.unitinfo,s.company,c.owner_address,s.dwtype from sp_owner s ,sp_owner_company c where s.company=c.owner_id and s.owner_code ='" . $device_code . "'");
        if (count($device_data) == 0) {
            echo '设备信息错误！';
            exit;
        }
        //判断是否报备和3小时以内相同设备报警未处理则不推送
        $this->redisShieldAlarm($device_data[0]['company'], $device_data[0]['dwtype'], $device_code, $time, $insert_id, $unique_number);
        $status_data['status'] = $Data['types'];
        if ($Data['types'] == '离线') {
            $status_data['where'] = " AND data2 like '%5%'";
        } else {
            $status_data['where'] = " AND data2 like '%4%'";
        }
        //设备基础信息查询
        $phone_data = M()->query("select phone from sp_owner_phone  WHERE owner_code='" . $device_data[0]['company'] . "' " . $status_data['where'] . "  and statusbb=1");
        if (count($phone_data) == 0) {
            echo 'phone is null';
            exit;
        }
        $phone = $this->array_column1($phone_data, "phone");
        $time_data = M()->query("SELECT statustime FROM sp_devices_status where deviceid='" . $device_code . "'");
        $op = M()->query("SELECT openid FROM sp_wx_opuser WHERE status=1 and type='wx' and idphone in($phone)");
        $access_token = GetAccess_Token1();
        $address = '警报地址：' . $device_data[0]['owner_address'] . $device_data[0]['unitinfo'];
        if (empty($time)) {
            $time = $time_data[0]['statustime'];
        }
        if (empty($remark)) {
            $remark = '设备名称：' . $device_data[0]['owner_name'];
        }
        if ($device_code == '4023383030303836' || $device_code == '4023383030303835' || $device_code == '4023383030303834'
            || $device_code == '4023383030303833' || $device_code == '4023383030303832' || $device_code == '4023383030303831'
            || $device_code == '4023383030303830' || $device_code == '4023383030303739') {
            $url = "https://iot.usky.cn/jdxf/wxapp5.php/Home/Fireinfo/index/type/6/id/" . $insert_id;
        } else {
            $url = "https://qhome.usky.cn/work/#/pages/proceDetailEle1/proceDetailEle1?type=6&id=" . $insert_id;
//            $url = "https://qhome.usky.cn/jdxf/wxapp2.php/Home/Fireinfo/index/type/6/id/" . $id;
        }

        foreach ($op as $key => $o) {
            if (!empty($o['openid'])) {
                $a = $this->SendDeviceAlarm($access_token, $o['openid'], $address, $device_code, $status_data['status'], $time, $remark, $url);
                //日志打印
                $this->printing_log($a, $filename_log, 'RTU', '返回');
            }
        }

    }

    /**
     * 可燃气体告警推送
     */
    public function gas_alarm()
    {
        $Data = I();
        //日志打印
        $filename_log = "/var/www/html/jdxf/log/krqt_log" . date("Y-m-d") . ".log";
        $this->printing_log($Data, $filename_log, '可燃气体', '参数');
        //参数获取
        $device_code = $this->getDeviceCode($Data);//设备编号
        $time = $Data['time'];//告警时间
        $insert_id = $Data['insert_id'];//告警表主键ID
        $remark = $Data['bz'];//备注
        $unique_number = $device_code;
        //设备基础信息查询1
        $device_data = M()->query("select s.owner_name,s.unitinfo,s.company,c.owner_address,s.dwtype from sp_owner s ,sp_owner_company c where s.company=c.owner_id and s.owner_code ='" . $device_code . "'");
        if (count($device_data) == 0) {
            echo '设备信息错误！';
            exit;
        }
        //判断是否报备和3小时以内相同设备报警未处理则不推送
        $this->redisShieldAlarm($device_data[0]['company'], $device_data[0]['dwtype'], $device_code, $time, $insert_id, $unique_number);
        //where条件和状态的判定
        $status_data = $this->getAlarmStatus($Data['evt']);
        //设备基础信息查询
        $phone_data = M()->query("select phone from sp_owner_phone  WHERE owner_code='" . $device_data[0]['company'] . "' " . $status_data['where'] . "  and statusbb=1");
        if (count($phone_data) == 0) {
            echo 'phone is null';
            exit;
        }
        $phone = $this->array_column1($phone_data, "phone");
        $op = M()->query("SELECT openid FROM sp_wx_opuser WHERE status=1 and type='wx' and idphone in($phone)");
        $access_token = GetAccess_Token1();
        $address = '警报地址：' . $device_data[0]['owner_address'] . $device_data[0]['unitinfo'];
        if (empty($remark)) {
            $remark = '设备名称：' . $device_data[0]['owner_name'];
        }
        //查看详情跳转路径
        $url = "https://qhome.usky.cn/work/#/pages/proceDetailEle1/proceDetailEle1?type=131&id=" . $insert_id;
//        $url = "https://qhome.usky.cn/jdxf/wxapp2.php/Home/Fireinfo/index/type/131/id/" . $id;

        foreach ($op as $o) {
            if (!empty($o['openid'])) {
                $a = $this->SendDeviceAlarm($access_token, $o['openid'], $address, $device_code, $status_data['status'], $time, $remark, $url);
                //日志打印
                $this->printing_log($a, $filename_log, '可燃气体', '返回');
            }
        }

    }

    /**
     * 门禁告警推送
     */
    public function mg_alarm()
    {
        $Data = I();
        //日志打印
        $filename_log = "/var/www/html/jdxf/log/mg_log" . date("Y-m-d") . ".log";//日志路径
        $this->printing_log($Data, $filename_log, '门禁', '参数');
        //参数获取
        $device_code = $this->getDeviceCode($Data);//设备编号
        $time = $Data['time'];//告警时间
        $insert_id = $Data['insert_id'];//告警表主键ID
        $remark = $Data['bz'];//备注
        $unique_number = $device_code;
        //设备基础信息查询1
        $device_data = M()->query("select s.owner_name,s.unitinfo,s.company,c.owner_address,s.dwtype from sp_owner s ,sp_owner_company c where s.company=c.owner_id and s.owner_code ='" . $device_code . "'");
        if (count($device_data) == 0) {
            echo '设备信息错误！';
            exit;
        }
        //判断是否报备和3小时以内相同设备报警未处理则不推送
        $this->redisShieldAlarm($device_data[0]['company'], $device_data[0]['dwtype'], $device_code, $time, $insert_id, $unique_number);
        //where条件和状态的判定
        $status_data = $this->getAlarmStatus($Data['evt']);
        //设备基础信息查询
        $phone_data = M()->query("select phone from sp_owner_phone  WHERE owner_code='" . $device_data[0]['company'] . "' " . $status_data['where'] . "  and statusbb=1");
        if (count($phone_data) == 0) {
            echo 'phone is null';
            exit;
        }
        $phone = $this->array_column1($phone_data, "phone");
        $op = M()->query("SELECT openid FROM sp_wx_opuser WHERE status=1 and type='wx' and idphone in($phone)");
        $access_token = GetAccess_Token1();
        $address = '警报地址：' . $device_data[0]['owner_address'] . $device_data[0]['unitinfo'];
        if (empty($remark)) {
            $remark = '设备名称：' . $device_data[0]['owner_name'];
        }
        //查看详情跳转路径
        $url = "https://qhome.usky.cn/work/#/pages/proceDetailEle1/proceDetailEle1?type=130&id=" . $insert_id;
//        $url = "https://qhome.usky.cn/jdxf/wxapp2.php/Home/Fireinfo/index/type/130/id/" . $id;
        foreach ($op as $o) {
            if (!empty($o['openid'])) {
                $a = $this->SendDeviceAlarm($access_token, $o['openid'], $address, $device_code, $status_data['status'], $time, $remark, $url);
                //日志打印
                $this->printing_log($a, $filename_log, '门禁', '返回');
            }
        }

    }

}