<?php

namespace Home\Controller;

use Think\Cache\Driver;
use Think\Controller;

include '../Common/function.php';

class WaterwarnController extends PushWarnController
{
    /**
     * 烟感告警推送
     */
    public function yg_alarm()
    {
        $Data = I();
        //日志打印
        $filename_log = "/var/www/html/jdxf/log/yg_log" . date("Y-m-d") . ".log";//日志路径
        $this->printing_log($Data, $filename_log, '烟感', '参数');
        //参数获取
        $device_code = $this->getDeviceCode($Data);//设备编号
        $time = $Data['time'];//告警时间
        $insert_id = $Data['insert_id'];//告警表主键ID
        $remark = $Data['bz'];//备注
        $unique_number = $device_code;
        //设备基础信息查询1
        $device_data = M()->query("select s.owner_name,s.unitinfo,s.company,c.owner_address,s.dwtype from sp_owner s ,sp_owner_company c where s.company=c.owner_id and s.owner_code ='" . $device_code . "'");
        if (count($device_data) == 0) {
            echo '设备信息错误！';
            exit;
        }
        //判断是否报备和3小时以内相同设备报警未处理则不推送
        $this->redisShieldAlarm($device_data[0]['company'], $device_data[0]['dwtype'], $device_code, $time, $insert_id, $unique_number);
        //where条件和状态的判定
        $status_data = $this->getAlarmStatus($Data['evt']);
        //设备基础信息查询
        $phone_data = M()->query("select phone from sp_owner_phone  WHERE owner_code='" . $device_data[0]['company'] . "' " . $status_data['where'] . "  and statusbb=1");
        if (count($phone_data) == 0) {
            echo 'phone is null';
            exit;
        }
        $phone = $this->array_column1($phone_data, "phone");
        $op = M()->query("SELECT openid FROM sp_wx_opuser WHERE status=1 and type='wx' and idphone in($phone)");
        $access_token = GetAccess_Token1();
        $address = '警报地址：' . $device_data[0]['owner_address'] . $device_data[0]['unitinfo'];
        if (empty($remark)) {
            $remark = '设备名称：' . $device_data[0]['owner_name'];
        }
        //查看详情跳转路径
        if ($Data['evt'] == 'ds01' || $Data['evt'] == 'ds02' || $Data['evt'] == 'ds03') {
            $url = "https://qhome.usky.cn/work/#/pages/proceDetailEle1/proceDetailEle1?type=130&id=" . $insert_id;
//            $url = "https://qhome.usky.cn/jdxf/wxapp2.php/Home/Fireinfo/index/type/130/id/" . $id;
        } else if ($Data['evt'] == 'gs01' || $Data['evt'] == 'gs02' || $Data['evt'] == 'gs03') {
            $url = "https://qhome.usky.cn/work/#/pages/proceDetailEle1/proceDetailEle1?type=131&id=" . $insert_id;
//            $url = "https://qhome.usky.cn/jdxf/wxapp2.php/Home/Fireinfo/index/type/131/id/" . $id;
        } else {
            $url = "https://qhome.usky.cn/work/#/pages/proceDetailEle1/proceDetailEle1?type=1&id=" . $insert_id;
//            $url = "https://qhome.usky.cn/jdxf/wxapp2.php/Home/Fireinfo/index/type/1/id/" . $id;
        }

        foreach ($op as $o) {
            if (!empty($o['openid'])) {
                $a = $this->SendDeviceAlarm($access_token, $o['openid'], $address, $device_code, $status_data['status'], $time, $remark, $url);
                //日志打印
                $this->printing_log($a, $filename_log, '烟感', '返回');
            }
        }

    }


    /**
     * 水警告警推送
     */
    public function message_water()
    {
        $Data = I();
        //日志打印
        $filename_log = "/var/www/html/jdxf/log/sj_log" . date("Y-m-d") . ".log";
        $this->printing_log($Data, $filename_log, '水警', '参数');
        //参数获取
        $device_code = $this->getDeviceCode($Data);//设备编号
        $insert_id = $Data['insert_id'];
        $time = $Data['time'];
        $remark = $Data['bz'];
        $nb_evt = $Data['evt_c'];
        $unique_number = $device_code;
        //设备基础信息查询1
        $device_data = M()->query("select s.owner_name,s.unitinfo,s.company,c.owner_address,s.dwtype from sp_owner s ,sp_owner_company c where s.company=c.owner_id and s.owner_code ='" . $device_code . "'");
        if (count($device_data) == 0) {
            echo '设备信息错误！';
            exit;
        }
        //判断是否报备和3小时以内相同设备报警未处理则不推送
        $this->redisShieldAlarm($device_data[0]['company'], $device_data[0]['dwtype'], $device_code, $time, $insert_id, $unique_number);
        if (!empty($nb_evt)) {
            $status_data['status'] = $nb_evt;
            $status_data['where'] = " AND data2 like '%3%'";
        } else {
            //where条件和状态的判定
            $status_data = $this->getAlarmStatus($Data['evt']);
        }
        //设备基础信息查询
        $phone_data = M()->query("select phone from sp_owner_phone  WHERE owner_code='" . $device_data[0]['company'] . "' " . $status_data['where'] . "  and statusbb=1");
        if (count($phone_data) == 0) {
            echo 'phone is null';
            exit;
        }
        $phone = $this->array_column1($phone_data, "phone");
        $time_data = M()->query("SELECT statustime FROM sp_devices_status where deviceid='" . $device_code . "'");
        $op = M()->query("SELECT openid FROM sp_wx_opuser WHERE status=1 and type='wx' and idphone in($phone)");
        $access_token = GetAccess_Token1();
        $address = '警报地址：' . $device_data[0]['owner_address'] . $device_data[0]['unitinfo'];
        if (empty($time)) {
            $time = $time_data[0]['statustime'];
        }
        if (empty($remark)) {
            $remark = '设备名称：' . $device_data[0]['owner_name'];
        }
        $url = "https://qhome.usky.cn/work/#/pages/proceDetailEle1/proceDetailEle1?type=2&id=" . $insert_id;
//        $url = "https://qhome.usky.cn/jdxf/wxapp2.php/Home/Fireinfo/index/type/2/id/" . $id;
        foreach ($op as $o) {
            if (!empty($o['openid'])) {
                $a = $this->SendDeviceAlarm($access_token, $o['openid'], $address, $device_code, $status_data['status'], $time, $remark, $url);
                //日志打印
                $this->printing_log($a, $filename_log, '水警', '返回');
            }
        }

    }


    /**
     * 电气火灾告警推送
     */
    public function message_electrical()
    {
        $Data = I();
        //日志打印
        $filename_log = "/var/www/html/jdxf/log/dqhz_log" . date("Y-m-d") . ".log";
        $this->printing_log($Data, $filename_log, '电器火灾', '参数');
        //参数获取
        $device_code = $this->getDeviceCode($Data);//设备编号
        $insert_id = $Data['insert_id'];
        $time = $Data['time'];
        $remark = $Data['bz'];
        $unique_number = $device_code;
        //设备基础信息查询1
        $device_data = M()->query("select s.owner_name,s.unitinfo,s.company,c.owner_address,s.dwtype from sp_owner s ,sp_owner_company c where s.company=c.owner_id and s.owner_code ='" . $device_code . "'");
        if (count($device_data) == 0) {
            echo '设备信息错误！';
            exit;
        }
        //判断是否报备和3小时以内相同设备报警未处理则不推送
        $this->redisShieldAlarm($device_data[0]['company'], $device_data[0]['dwtype'], $device_code, $time, $insert_id, $unique_number);
        //where条件和状态的判定
        $status_data = $this->getAlarmStatus($Data['evt']);
        //设备基础信息查询
        $phone_data = M()->query("select phone from sp_owner_phone  WHERE owner_code='" . $device_data[0]['company'] . "' " . $status_data['where'] . "  and statusbb=1");
        if (count($phone_data) == 0) {
            echo 'open is null';
            exit;
        }
        $phone = $this->array_column1($phone_data, "phone");
        $op = M()->query("SELECT openid FROM sp_wx_opuser WHERE status=1 and type='wx' and idphone in($phone)");
        $access_token = GetAccess_Token1();
        $address = '警报地址：' . $device_data[0]['owner_address'] . $device_data[0]['unitinfo'];
        if (empty($time)) {
            $time = date('Y-m-d H:i:s');
        }
        if (empty($remark)) {
            $remark = '设备名称：' . $device_data[0]['owner_name'];
        }
        $url = "https://qhome.usky.cn/work/#/pages/proceDetailEle1/proceDetailEle1?type=7&id=" . $insert_id;
//        $url = "https://qhome.usky.cn/jdxf/wxapp2.php/Home/Fireinfo/index/type/7/id/" . $id;
        foreach ($op as $o) {
            if (!empty($o['openid'])) {
                $a = $this->SendDeviceAlarm($access_token, $o['openid'], $address, $device_code, $status_data['status'], $time, $remark, $url);
                //日志打印
                $this->printing_log($a, $filename_log, '电器火灾', '返回');
            }
        }

    }

}