<?php

namespace Home\Controller;

use Think\Controller;

include '../Common/function.php';

class WorkOrderNoticeController extends PushWarnController
{
    //督查单告警推送一
    public function message_workordernotice()
    {
        $Data = I('post.');
        $company_code = $Data['company_code'];
        $time = $Data['time'];
        $id = $Data['id'];
        $title = str_replace('[&quot;', '', str_replace('&quot;]', '', $Data['title']));
        $filename_log = "/var/www/html/jdxf/log/dcd_log" . date("Y-m-d") . ".log";
        //日志打印
        $this->printing_log($Data, $filename_log, '督查单一', '参数');
        $company = M()->query("select owner_name from sp_owner_company where owner_id='" . $company_code."'");
        $op = M()->query("SELECT openid FROM sp_wx_opuser WHERE status=1 and type='wx' and idphone in(select phone from sp_owner_phone where  owner_code='".$company_code."')");
        $access_token = GetAccess_Token1();
        $content = '单  位：' . $company[0]['owner_name'];
        if ($Data['types'] == 2) {
            $type = '电子督察单（重要）';
            $url = "https://qhome.usky.cn/work/index.html#/pages/inspectList/processDetailEle1/processDetailEle1?type=2&id=" . $id ;
//            $url = "https://qhome.usky.cn/jdxf/wxapp2.php/Home/FireInspector/index1/id/" . $id . "/companyid/" . $company_code;
        } else if ($Data['types'] == 1) {
            $type = '人工督察单（重要）';
            $url = "https://qhome.usky.cn/work/index.html#/pages/inspectList/processDetailEle1/processDetailEle1?type=1&id=" . $id ;
//            $url = "https://qhome.usky.cn/jdxf/wxapp2.php/Home/FireInspector/index/id/" . $id . "/companyid/" . $company_code;
        } else {
            $type = '人工督察单（重要）';
            $url = "https://qhome.usky.cn/work/index.html#/pages/inspectList/processDetailEle1/processDetailEle1?type=".$Data['types']."&id=" . $id ;
//            $url = "https://qhome.usky.cn/jdxf/wxapp2.php/Home/FireInspector/index/id/" . $id . "/companyid/" . $company_code;
        }
        $people = '消防支队';
        $remark = '时  间：' . $time;
        if ($title == "设备离线") {
            echo '离线过滤';
            exit();
        }

        foreach ($op as $o) {
            if (!empty($o['openid'])) {
                $arr = $this->SendDeviceAlarm1($access_token, $o['openid'], $content, $type, $title, $people, $remark, $url);
                print_r($arr);
                //日志打印
                $this->printing_log($arr, $filename_log, '督查单一', '返回');
            }
        }

    }

    //督查单告警推送二
    public function message_notice()
    {
        $Data = I('post.');
        $company_code = $Data['company_code'];
        $time = $Data['time'];
        $id = $Data['id'];
        $title = str_replace('[&quot;', '', str_replace('&quot;]', '', $Data['title']));
        $filename_log = "/var/www/html/jdxf/log/dcd_log" . date("Y-m-d") . ".log";
        //日志打印
        $this->printing_log($Data, $filename_log, '督查单二', '参数');
        $company = M()->query("select owner_name from sp_owner_company where  owner_id=" . $company_code);
        $op = M()->query("SELECT openid FROM sp_wx_opuser WHERE status=1 and type='wx' and idphone in(select phone from sp_owner_phone where  owner_code='".$company_code."')");
//        $op = M()->query("SELECT openid FROM sp_wx_customuser WHERE type='wx' and idphone in(select phone from(select phone from sp_owner_phone  WHERE owner_code='" . $company_code . "'  union select phone from sp_owner_phone  WHERE owner_code in (select other_code from sp_owner_fujin where owner_code='" . $company_code . "')) t )");
        $access_token = GetAccess_Token1();
        $content = '单  位：' . $company[0]['owner_name'];
        $type = '人工督察单（重要）';
        $people = '消防支队';
        $remark = '时  间：' . $time;
        $url = "";
        foreach ($op as $o) {
            if (!empty($o['openid'])) {
                $arr = $this->SendDeviceAlarm1($access_token, $o['openid'], $content, $type, $title, $people, $remark, $url);
                print_r($arr);
                //日志打印
                $this->printing_log($arr, $filename_log, '督查单二', '返回');
            }
        }

    }
}